package com.sf.oauth.config;

import lombok.*;

import java.util.List;

/**
 * 配置类
 *
 * @author zoukun
 */
@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class AuthConfig {

    /**
     * 客户端id：对应各平台的appKey
     */
    private String clientId;

    /**
     * 客户端Secret：对应各平台的appSecret
     */
    private String clientSecret;

    /**
     * 登录成功后的回调地址
     */
    private String redirectUri;

    /**
     * 支持自定义授权平台的 scope 内容
     */
    private List<String> scopes;

    private boolean ignoreCheckState;

}
